(* ################################### Module : fonctions de traitement sur les canaux de communication *)
(* ------ message sur la console *)
let print chaine =
  print_string chaine; print_newline ();;
(* ------ message dans un canal ouvert en écriture *)
let write canal chaine =
  output_string canal chaine; flush canal;;
  
(* lire un canal jusqu'à rencontrer un caractère -> chaîne *)                     (* à revoir *)
let lire_canal canal car_fin nbr_phr =
  let buf = Buffer.create 80 and carac = ref '\n' and c = ref 0 in
  while (!c <> nbr_phr) do
    if !carac <> car_fin then Buffer.add_char buf !carac;
    carac := input_char canal;
    if !carac = car_fin then (incr c;)
  done;
  let chaine = Buffer.contents buf in
  chaine;;
(* lire un fichier en mode binaire -> une chaîne utf8 *)
let file_to_string file = 
	let ic = open_in_bin (Glib.Convert.filename_from_utf8 file) in 
	let s = ref "" in
	begin
	try 
		while true do
			s:= !s ^ (input_line ic) ^ "\n"
		done
	with 
		End_of_file -> close_in ic ;
	end;
	Glib.Convert.locale_to_utf8 (!s);;
(* écrire un fichier depuis une chaîne utf_ *)
let string_to_file file txt =
	let canal = open_out_bin (Glib.Convert.filename_from_utf8 file) in
	let texte = Glib.Convert.locale_from_utf8 (txt) in
	output_string canal texte;
	close_out canal;;
